diff --git a/src/dosext/mfs/mangle.c b/src/dosext/mfs/mangle.c
index 9b8c6b2b65..e72c8112ae 100644
--- a/src/dosext/mfs/mangle.c
+++ b/src/dosext/mfs/mangle.c
@@ -64,7 +64,7 @@ static int str_checksum(char *s)
 check if a name is a special msdos reserved name:
 the name is either a full Unix name or an 8 character candidate
 ****************************************************************************/
-FAR_PTR is_dos_device(const char *path)
+dosaddr_t is_dos_device(const char *path)
 {
   char *p;
   const char *fname;
@@ -143,6 +143,14 @@ FAR_PTR is_dos_device(const char *path)
   return 0;
 }
 
+dosaddr_t is_dos_device8(const char *fname)
+{
+  dosaddr_t ret;
+  char *fpath = strndup(fname, 8);
+  ret = is_dos_device(fpath);
+  free(fpath);
+  return ret;
+}
 
 /****************************************************************************
 return True if a name is in 8.3 dos format
diff --git a/src/dosext/mfs/mangle.h b/src/dosext/mfs/mangle.h
index 56ce97535b..b362cd87bd 100644
--- a/src/dosext/mfs/mangle.h
+++ b/src/dosext/mfs/mangle.h
@@ -40,6 +40,7 @@ typedef char pstring[1024];
 
 /* prototypes */
 extern dosaddr_t is_dos_device(const char *fname);
+extern dosaddr_t is_dos_device8(const char *fname);
 extern BOOL do_fwd_mangled_map(char *s, char *MangledMap);
 extern BOOL name_convert(char *Name,BOOL mangle);
 extern BOOL is_mangled(const char *s);
diff --git a/src/dosext/mfs/mfs.c b/src/dosext/mfs/mfs.c
index 733268b22c..241afe1f85 100644
--- a/src/dosext/mfs/mfs.c
+++ b/src/dosext/mfs/mfs.c
@@ -1829,7 +1829,7 @@ static struct dir_list *get_dir_ff(char *name, char *mname, char *mext,
  *
  * DANG_END_REMARK
  */
-  if (is_dos_device(mname)) {
+  if (is_dos_device8(mname)) {
     dir_list = make_dir_list(1);
     entry = make_entry(dir_list);
 
@@ -2635,7 +2635,7 @@ compare(char *fname, char *fext, char *mname, char *mext)
     }
   }
   /* if got here then name matches */
-  if (is_dos_device(mname))
+  if (is_dos_device8(mname))
     return (TRUE);
 
   /* match ext next */
